=== debian/changelog ===
libchewing (0.8.4-2build1) oracular; urgency=medium

  * No-change rebuild to enable frame pointers

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 01 Jul 2024 17:40:10 +0200

libchewing (0.8.4-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.0.
  * Fix typo in patch file.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 06 Jun 2024 10:21:35 +0800

libchewing (0.8.4-1) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * New upstream release.
  * d/control: Add chewing-tools package for command line tools.
  * d/rules: Use dh_missing to find missing files during packaging.

  [ Kan-Ru Chen (陳侃如) ]
  * Fix Build-Depends for Rust.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 04 Jun 2024 19:59:30 +0800

libchewing (0.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Update d/copyright:
    * Change license to LGPL-2.1+ as described in
      https://github.com/chewing/libchewing/pull/436.
    * Remove unused copyright.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 07 Apr 2024 21:11:03 +0800
