=== debian/changelog ===
libchewing (0.9.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove unused copyright.
  * Add CMake config.
  * Update symbol file for symbol versioning.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 12 Aug 2024 12:37:40 +0800

libchewing (0.8.5-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 16 Jul 2024 22:59:29 +0800
