=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -7,21 +7,13 @@
     test-keyboard
     test-keyboardless
     test-logger
-    test-path
     test-regression
     test-reset
     test-special-symbol
     test-struct-size
     test-symbol
     test-userphrase
-    test-utf8
 )
-if(NOT WITH_RUST)
-    list(APPEND ALL_TESTCASES
-        test-key2pho
-        test-mmap
-    )
-endif()
 set(ALL_TESTTOOLS
     performance
     randkeystroke
@@ -57,9 +49,7 @@
 foreach(target ${ALL_TESTS})
     add_executable(${target} ${TEST_SRC_DIR}/${target}.c)
     target_link_libraries(${target} testhelper)
-    if(WITH_RUST)
-        target_link_libraries(${target} chewing_testhelper)
-    endif(WITH_RUST)
+    target_link_libraries(${target} chewing_testhelper)
     target_link_libraries(${target} libchewing)
     target_compile_definitions(${target} PRIVATE
         CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
@@ -73,7 +63,14 @@
 
 add_library(testhelper STATIC
     ${TEST_SRC_DIR}/testhelper.c
-    $<TARGET_OBJECTS:common>
+    ${TEST_SRC_DIR}/porting_layer/src/asprintf.c
+    ${TEST_SRC_DIR}/porting_layer/src/asprintf.h
+    ${TEST_SRC_DIR}/porting_layer/include/plat_types.h
+    ${TEST_SRC_DIR}/porting_layer/include/sys/plat_posix.h
+    ${TEST_SRC_DIR}/porting_layer/include/sys/plat_windows.h
+)
+target_include_directories(testhelper PUBLIC
+        ${TEST_SRC_DIR}/porting_layer/include
 )
 target_compile_definitions(testhelper PRIVATE
     CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
@@ -103,7 +100,5 @@
     add_dependencies(check ${target})
 endforeach()
 
-if(WITH_RUST)
 add_test(NAME cargo-test-lib COMMAND cargo test --features $<$<BOOL:${WITH_SQLITE3}>:sqlite>)
 add_test(NAME cargo-test-capi COMMAND cargo test -p chewing_capi --features $<$<BOOL:${WITH_SQLITE3}>:sqlite>)
-endif()
