=== debian/changelog ===
libchewing (0.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 Oct 2024 23:32:43 +0800
