=== debian/changelog ===
libchewing (0.10.0-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 Jul 2025 22:53:20 +0800
