## libchewing 0.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.24.0...3.31.6)
 project(libchewing LANGUAGES C)
 
-set(CMAKE_PROJECT_VERSION 0.10.0)
+set(CMAKE_PROJECT_VERSION 0.10.1)
 
 find_package(Git)
 if(Git_FOUND)
@@ -39,7 +39,7 @@
 option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
 
 if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
-    set(CMAKE_C_FLAGS "-std=gnu99 ${CMAKE_C_FLAGS}")
+    set(CMAKE_C_FLAGS "-std=gnu99 -finput-charset=utf-8 ${CMAKE_C_FLAGS}")
     add_compile_definitions(_GNU_SOURCE)
     option(ENABLE_GCOV "Coverage support" false)
     if(ENABLE_GCOV)
