=== debian/changelog ===
libchewing (0.10.1-1) unstable; urgency=medium

  * New upstream release.
  * d/salsa-ci.yml: Add Salsa CI config.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 02 Aug 2025 16:19:04 +0800
