=== debian/tests/control ===
Tests: build
Depends:
 build-essential,
 libchewing3-dev,
 pkg-config,
