## libchewing 0.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.24.0...3.31.6)
 project(libchewing LANGUAGES C)
 
-set(CMAKE_PROJECT_VERSION 0.10.1)
+set(CMAKE_PROJECT_VERSION 0.10.2)
 
 find_package(Git)
 if(Git_FOUND)
