=== debian/changelog ===
libchewing (0.10.2-1) unstable; urgency=medium

  * New upstream version 0.10.2

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 14 Aug 2025 21:12:31 +0800
